/*
 * extb plugin to VDR (C++)
 *
 * (C) 2004 - 2007 Andreas Brachold <vdr04-at-deltab-dot-de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#ifndef __EXTN_LIRCWATCH_H
#define __EXTB_LIRCWATCH_H

#include <vdr/thread.h>

class cExtBLircWatch : private cThread {
private:
  enum { LIRC_KEY_BUF = 30, LIRC_BUFFER_SIZE = 128 };
  volatile bool m_bShutdown;
  bool m_bWatchSuccess;
  bool m_bWatch;
  int m_fd;

  int m_nVideoModes;
  int m_nScartBootModes;
  bool m_bVideoFound;
  bool m_bScartBootFound;
protected:
  virtual void Action(void);
  void close();
public:
  cExtBLircWatch(const char *DeviceName);
  virtual ~cExtBLircWatch();
  void StartWatch(void);
  bool WatchSuccess(void) const     { return (m_bWatchSuccess); }
  int GetVideoModes(void) const     { return (m_nVideoModes); }
  int GetScartBootModes(void) const { return (m_nScartBootModes); }
};

#endif
